> For the complete documentation index, see [llms.txt](https://docs.mediarithmics.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mediarithmics.io/api-reference/datamart-segment-and-feed-operations/feed-destinations.md).

# Feed Destinations

Operations related to Feed Destinations for managing external feed destination configurations.

## GET /feed\_destinations/{id}

> Get Feed destination

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Feed Destinations","description":"Operations related to Feed Destinations for managing external feed destination configurations."}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/feed_destinations/{id}":{"get":{"operationId":"getFeedDestination","description":"","responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/FeedDestinationResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"tags":["Feed Destinations"],"parameters":[{"explode":false,"schema":{"type":"string"},"required":true,"in":"path","style":"simple","name":"id"}],"summary":"Get Feed destination"}}},"components":{"schemas":{"FeedDestinationResource":{"type":"object","properties":{"credentials_last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"last_auth_status":{"type":"string","readOnly":true},"last_auth_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"organisation_id":{"type":"string","readOnly":false},"last_modified_by":{"type":"string","readOnly":true},"plugin_version_id":{"type":"string","readOnly":false},"id":{"type":"string","readOnly":true},"creation_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"created_by":{"type":"string","readOnly":true},"description":{"type":"string","readOnly":false},"last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"name":{"type":"string","readOnly":false}},"required":["id","name","organisation_id"]},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## PUT /feed\_destinations/{id}

> Update a Feed destination

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Feed Destinations","description":"Operations related to Feed Destinations for managing external feed destination configurations."}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/feed_destinations/{id}":{"put":{"tags":["Feed Destinations"],"summary":"Update a Feed destination","parameters":[{"required":true,"style":"simple","name":"id","explode":false,"schema":{"type":"string"},"in":"path"}],"operationId":"updateFeedDestination","description":"","responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/FeedDestinationResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"requestBody":{"description":"The feed destination to update","content":{"application/json":{"schema":{"$ref":"#/components/schemas/FeedDestinationResource"}}},"required":true}}}},"components":{"schemas":{"FeedDestinationResource":{"type":"object","properties":{"credentials_last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"last_auth_status":{"type":"string","readOnly":true},"last_auth_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"organisation_id":{"type":"string","readOnly":false},"last_modified_by":{"type":"string","readOnly":true},"plugin_version_id":{"type":"string","readOnly":false},"id":{"type":"string","readOnly":true},"creation_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"created_by":{"type":"string","readOnly":true},"description":{"type":"string","readOnly":false},"last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"name":{"type":"string","readOnly":false}},"required":["id","name","organisation_id"]},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## DELETE /feed\_destinations/{id}

> Delete a Feed destination

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Feed Destinations","description":"Operations related to Feed Destinations for managing external feed destination configurations."}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/feed_destinations/{id}":{"delete":{"tags":["Feed Destinations"],"summary":"Delete a Feed destination","responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/FeedDestinationResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"operationId":"deleteFeedDestination","description":"","parameters":[{"required":true,"schema":{"type":"string"},"name":"id","in":"path","style":"simple","explode":false}]}}},"components":{"schemas":{"FeedDestinationResource":{"type":"object","properties":{"credentials_last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"last_auth_status":{"type":"string","readOnly":true},"last_auth_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"organisation_id":{"type":"string","readOnly":false},"last_modified_by":{"type":"string","readOnly":true},"plugin_version_id":{"type":"string","readOnly":false},"id":{"type":"string","readOnly":true},"creation_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"created_by":{"type":"string","readOnly":true},"description":{"type":"string","readOnly":false},"last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"name":{"type":"string","readOnly":false}},"required":["id","name","organisation_id"]},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## GET /feed\_destinations

> Search Feed destinations

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Feed Destinations","description":"Operations related to Feed Destinations for managing external feed destination configurations."}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/feed_destinations":{"get":{"parameters":[{"name":"first_result","in":"query","required":false,"explode":true,"schema":{"type":"integer","format":"int32"},"description":"Offset from which the search must be performed","style":"form"},{"description":"Number of maximum items that shall be return by this search","style":"form","name":"max_results","schema":{"type":"integer","format":"int32"},"required":false,"explode":true,"in":"query"},{"name":"organisation_id","required":true,"style":"form","description":"Organisation owning the feed destination","schema":{"type":"integer","format":"int64"},"explode":true,"in":"query"},{"description":"Filter by plugin version id","schema":{"type":"integer","format":"int64"},"explode":true,"required":false,"name":"plugin_version_id","in":"query","style":"form"}],"operationId":"findFeedDestinations","summary":"Search Feed destinations","responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"total":{"type":"integer"},"status":{"type":"string","enum":["ok"]},"max_results":{"type":"integer"},"data":{"type":"array","items":{"$ref":"#/components/schemas/FeedDestinationResource"}},"first_result":{"type":"integer"},"count":{"type":"integer"}},"required":["count","data","first_result","max_results","status","total"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"tags":["Feed Destinations"],"description":""}}},"components":{"schemas":{"FeedDestinationResource":{"type":"object","properties":{"credentials_last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"last_auth_status":{"type":"string","readOnly":true},"last_auth_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"organisation_id":{"type":"string","readOnly":false},"last_modified_by":{"type":"string","readOnly":true},"plugin_version_id":{"type":"string","readOnly":false},"id":{"type":"string","readOnly":true},"creation_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"created_by":{"type":"string","readOnly":true},"description":{"type":"string","readOnly":false},"last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"name":{"type":"string","readOnly":false}},"required":["id","name","organisation_id"]},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## POST /feed\_destinations

> Create a Feed destination

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Feed Destinations","description":"Operations related to Feed Destinations for managing external feed destination configurations."}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/feed_destinations":{"post":{"summary":"Create a Feed destination","tags":["Feed Destinations"],"requestBody":{"description":"The feed destination to create","content":{"application/json":{"schema":{"$ref":"#/components/schemas/FeedDestinationResource"}}},"required":true},"operationId":"createFeedDestination","responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/FeedDestinationResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"description":""}}},"components":{"schemas":{"FeedDestinationResource":{"type":"object","properties":{"credentials_last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"last_auth_status":{"type":"string","readOnly":true},"last_auth_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"organisation_id":{"type":"string","readOnly":false},"last_modified_by":{"type":"string","readOnly":true},"plugin_version_id":{"type":"string","readOnly":false},"id":{"type":"string","readOnly":true},"creation_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"created_by":{"type":"string","readOnly":true},"description":{"type":"string","readOnly":false},"last_modified_ts":{"type":"integer","format":"int64","default":0,"readOnly":true},"name":{"type":"string","readOnly":false}},"required":["id","name","organisation_id"]},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## POST /feed\_destinations/{id}/oauth\_redirect\_url

> Create an OAuth redirect URL for a Feed destination

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Feed Destinations","description":"Operations related to Feed Destinations for managing external feed destination configurations."}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/feed_destinations/{id}/oauth_redirect_url":{"post":{"responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/FeedDestinationOAuthRedirectUrlResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"parameters":[{"style":"simple","explode":false,"schema":{"type":"string"},"required":true,"name":"id","in":"path"}],"summary":"Create an OAuth redirect URL for a Feed destination","operationId":"createFeedDestinationOAuthRedirectUrl","description":"","tags":["Feed Destinations"]}}},"components":{"schemas":{"FeedDestinationOAuthRedirectUrlResource":{"type":"object","properties":{"login_url":{"type":"string","readOnly":false}},"required":["login_url"]},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```

## POST /feed\_destinations/{id}/credentials

> Create or replace credentials for a Feed destination

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Feed Destinations","description":"Operations related to Feed Destinations for managing external feed destination configurations."}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/feed_destinations/{id}/credentials":{"post":{"parameters":[{"name":"id","style":"simple","explode":false,"required":true,"schema":{"type":"string"},"in":"path"}],"tags":["Feed Destinations"],"operationId":"upsertFeedDestinationCredentials","summary":"Create or replace credentials for a Feed destination","description":"","responses":{"200":{"$ref":"#/components/responses/simple"},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"requestBody":{"description":"Credentials","content":{"application/json":{"schema":{"$ref":"#/components/schemas/FeedDestinationCredentialsResource"}}},"required":true}}}},"components":{"responses":{"simple":{"description":"Success response","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]}},"required":["status"]}}}},"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}},"schemas":{"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]},"FeedDestinationCredentialsResource":{"type":"object","properties":{"scheme":{"$ref":"#/components/schemas/TenantCredentialsScheme"},"credentials":{"type":"string","readOnly":false}},"required":["credentials","scheme"]},"TenantCredentialsScheme":{"type":"string","enum":["GOOGLE_SERVICE_ACCOUNT","NO_CREDENTIALS","JDBC_CREDENTIALS","SNOWFLAKE","HMAC","S3","OAUTH2","API_TOKEN","LOGIN_PASSWORD"],"readOnly":false}}}}
```

## POST /feed\_destinations/{id}/test\_authentication

> Test stored credentials for a Feed destination

```json
{"openapi":"3.1.1","info":{"title":"mediarithmics openapi API","version":"1.0.0"},"tags":[{"name":"Feed Destinations","description":"Operations related to Feed Destinations for managing external feed destination configurations."}],"servers":[{"url":"http://api.mediarithmics.local/v1","description":"Development server"},{"url":"https://api.mediarithmics.com/v1","description":"Production server"}],"paths":{"/feed_destinations/{id}/test_authentication":{"post":{"tags":["Feed Destinations"],"responses":{"200":{"description":"Success !","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","enum":["ok"]},"data":{"$ref":"#/components/schemas/FeedDestinationAuthStatusResource"}},"required":["data","status"]}}}},"400":{"$ref":"#/components/responses/error"},"401":{"$ref":"#/components/responses/error"},"403":{"$ref":"#/components/responses/error"},"404":{"$ref":"#/components/responses/error"},"500":{"$ref":"#/components/responses/error"},"503":{"$ref":"#/components/responses/error"}},"summary":"Test stored credentials for a Feed destination","operationId":"testFeedDestinationAuthentication","parameters":[{"style":"simple","required":true,"explode":false,"in":"path","schema":{"type":"string"},"name":"id"},{"in":"query","schema":{"type":"integer","format":"int64"},"description":"Epoch-millis reference timestamp. When provided and the stored credentials have not been modified after it, the status is returned as TO_VALIDATE without calling the plugin (used while polling for a reauthorization to land new credentials).","required":false,"style":"form","explode":true,"name":"credentials_modified_after"}],"description":""}}},"components":{"schemas":{"FeedDestinationAuthStatusResource":{"type":"object","properties":{"status":{"$ref":"#/components/schemas/FeedAuthStatus"},"last_auth_ts":{"type":"integer","format":"int64","default":0,"readOnly":false}},"required":["last_auth_ts","status"]},"FeedAuthStatus":{"type":"string","enum":["AUTHENTICATED","TO_VALIDATE","INVALID_CREDENTIALS","ERROR"],"readOnly":false},"errorResponse":{"type":"object","properties":{"status":{"type":"string","enum":["error"]},"error_code":{"type":"string","enum":["AUTHENTICATION_ERROR","AUTHORIZATION_ERROR","BAD_REQUEST_DATA","BAD_REQUEST_FORMAT","CONSTRAINT_VIOLATION_EXCEPTION","EMAIL_ALREADY_EXISTS","MAC_ERROR","RESOURCE_NOT_FOUND","SERVICE_UNAVAILABLE","TOKEN_ERROR"]},"error_id":{"type":"string"},"error":{"type":"string"}},"required":["error","error_code","error_id","status"]}},"responses":{"error":{"description":"Error response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/errorResponse"}}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.mediarithmics.io/api-reference/datamart-segment-and-feed-operations/feed-destinations.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
